#include "draw.h"

extern drawData  data;

int copy, oldx, oldy;

void StartCopy(w, event)
Widget  w;
XEvent  *event;
{
    int pick;

    pick = FindPick(event->xbutton.x, event->xbutton.y);
    if ((pick != -1) && (data.cPoly < MAXDESCSIZE)){
       data.doingCopy = TRUE;
       oldx = event->xbutton.x;
       oldy = event->xbutton.y;
       GrabPointer();
       copy = data.cPoly;
       data.cPoly++;
       SetPolyNumLabel();
       data.pic[copy] = data.pic[pick];
       DrawXorPoly(copy);
    }
}

void MoveCopy(w, event)
Widget  w;
XEvent  *event;
{
    int i, dx, dy;

    dx = event->xbutton.x - oldx;
    dy = event->xbutton.y - oldy;
    if (MoveOk(copy, dx, dy)) {
       DrawXorPoly(copy);
       for (i = 0; i < data.pic[copy].size; i++) {
          data.pic[copy].points[i].x += dx;
          data.pic[copy].points[i].y += dy;
       }
       DrawXorPoly(copy);
    }
    oldx = event->xbutton.x;
    oldy = event->xbutton.y;
}

void UpdateCopy(w, event)
Widget     w;
XEvent     *event;
{
    int i, dx, dy;

    DrawXorPoly(copy);
    data.doingCopy = FALSE;
    dx = event->xbutton.x - oldx;
    dy = event->xbutton.y - oldy;
    for (i = 0; i < data.pic[copy].size; i++) {
       data.pic[copy].points[i].x += dx;
       data.pic[copy].points[i].y += dy;
    }
    DrawPoly(copy);
    UpdateUndo();
    SetPolyNumLabel();
    ClearPicture();
    RedrawPicture();
    UngrabPointer();
}
