#include "draw.h" 

CreateWidgets(argc, argv)
int  argc;
char **argv;
{
   Widget toplevel, pane, bigBox, box, canvas;
   Widget CreateShellWidget(), CreatePane(), CreateBox();
   Widget CreateColorBox(), CreateCanvas();
   
   toplevel = CreateShellWidget(argc, argv);
   dpy = XtDisplay(toplevel);
   MakeIcon(toplevel);
   MakeColors();
   SetColormap(toplevel);

   pane = CreatePane(toplevel);
   box = CreateBox(pane);
   CreateOptionButton(box, "Quit", 1);
   CreateOptionButton(box, "Clear", 2);
   CreateOptionButton(box, "Load", 3);
   CreateOptionButton(box, "Save", 4);
   CreateOptionButton(box, "Background", 5);
   CreateOptionButton(box, "Undo", 6);
   CreateOptionButton(box, "Redo",7);
   CreatePolyNumLabel(box);
   box = CreateBox(pane);
   CreateRadioButton(box, "Polygon", 1);
   CreateRadioButton(box, "Rectangle", 2);
   CreateRadioButton(box, "Ellipse", 3);
   CreateRadioButton(box, "Move", 4);
   CreateRadioButton(box, "Copy", 5);
   CreateRadioButton(box, "Point Adjust", 6);
   CreateRadioButton(box, "Back", 7);
   CreateRadioButton(box, "Forward",8);
   CreateRadioButton(box, "Delete",9);
   bigBox = CreateBox(pane);
   box = CreateColorBox(bigBox);
   CreateColorButtons(box);
   canvas = CreateCanvas(bigBox, WIDTH, HEIGHT);

   XtRealizeWidget(toplevel);
   AddEventHandlers(canvas);
   CreateGCs(canvas);
}

MainLoop()
{
   XtMainLoop();
}

